package weaver.haikang.cronjob;

import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.schedule.BaseCronJob;


/**
 * 定时合计 人员部门  刷新到一级二级三级四级去
 */
public class PersonDeptLevelCron extends BaseCronJob {
    private final Logger log = LoggerFactory.getLogger(PersonDeptLevelCron.class);

    private String currentYear;

    @Override
    public void execute() {

        log.error("新到一级二级三级四级定时任务开启-------");
        new Thread( ()->{
            PersonDeptLevelCronService personDeptLevelCronService = new PersonDeptLevelCronService();
            personDeptLevelCronService.execute();
        }).start();
        log.error("新到一级二级三级四级定时任务结束-------");
    }
}
